# Web Cell

Light-weight **[Web Components](https://www.webcomponents.org/) engine** based on ECMAScript 6+, powered by the practice & experience from developing [EWA v1.0 ~ 4.0](https://gitee.com/Tech_Query/EasyWebApp/).

[![Join the chat at https://gitter.im/EasyWebApp-js/Lobby](https://badges.gitter.im/EasyWebApp-js/Lobby.svg)](https://gitter.im/EasyWebApp-js/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)

[![NPM Dependency](https://david-dm.org/EasyWebApp/WebCell.svg)](https://david-dm.org/EasyWebApp/WebCell)

[![NPM](https://nodei.co/npm/web-cell.png?downloads=true&downloadRank=true&stars=true)](https://nodei.co/npm/web-cell/)



## Basic Usage

First

```Shell
npm install web-cell
```
then

```HTML
<!DocType HTML>
<html><head>
    <script src="https://cdn.bootcss.com/webcomponentsjs/1.2.0/webcomponents-lite.js"></script>
    <script src="node_modules/web-cell/build/WebCell.js"></script>

    <link rel="import" href="path/to/your-component/index.html" />
    <!-- More Import tags of your Web components -->
</head><body>
    <your-component></your-component>
</body></html>
```
If you use [ESLint](https://eslint.org/), add options below into its configuration:

```JSON
{
    "globals": {
        "WebCell": false
    }
}
```


## API document

 - Online --- https://web-cell.tk/

 - Offline --- `npm start`



## Component library

 1. [BootCell](https://github.com/EasyWebApp/BootCell) based on BootStrap v4
