//
//  Generated by https://www.npmjs.com/package/amd-bundle
//
(function (factory) {

    if ((typeof define === 'function')  &&  define.amd)
        define('WebCell', factory);
    else if (typeof module === 'object')
        return  module.exports = factory();
    else
        return  this.WebCell = factory();

})(function () {

    var module = {
        './View':  {exports: { }},
        './Template':  {exports: { }},
        './ArrayView':  {exports: { }},
        './ObjectView':  {exports: { }},
        './Component':  {exports: { }},
        './WebCell':  {exports: { }}
    };

function merge(base, path) {

    return (base + '/' + path).replace(/\/\//g, '/').replace(/[^/.]+\/\.\.\//g, '').replace(/\.\//g, function (match, index, input) {

        return input[index - 1] === '.' ? match : '';
    });
}

    function _require_(base, path) {

        return module[
            /^\w/.test( path )  ?  path  :  ('./' + merge(base, path))
        ].exports;
    }

    var require = _require_.bind(null, './');

function _View(require, exports, module) {'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var view_DOM = new WeakMap(),
    DOM_view = new WeakMap(),
    view_data = new WeakMap();

/**
 * Abstract View
 */

var View = function () {
    /**
     * @param {string|Element|DocumentFragment} template
     * @param {string}                          nameKey  - Key (littleCamelCase) of HTML `data-*`
     *                                                     to get name of bound data
     * @param {Object}                          scope    - Empty Model for this view
     */
    function View(template, nameKey, scope) {
        _classCallCheck(this, View);

        if (this.constructor === View) throw TypeError('"View" is an abstract class');

        switch (template.nodeType) {
            case 1:
                this.name = template.dataset[nameKey];break;
            case 11:
                if (!(template.parentNode || template.host)) template = Array.from(template.childNodes);
                break;
            default:
                template = View.parseDOM(template);
        }

        var _this_ = this.bindWith(template);

        if (_this_ !== this) {

            _this_.booted = true;

            return _this_;
        }

        view_data.set(this, scope);
    }

    /**
     * @param {Node} node - Node from other `Document`
     *
     * @return {Node} Cloned & imported Node (with its child nodes)
     */


    _createClass(View, [{
        key: 'bindWith',


        /**
         * @protected
         *
         * @param {Element|Element[]|DocumentFragment} template
         *
         * @return {View} This view or the view bound before
         */
        value: function bindWith(template) {
            var _this = this;

            var _this_;

            if (template instanceof Array) template = template.filter(function (node) {

                switch (node.nodeType) {
                    case 1:
                        if (!(_this_ = DOM_view.get(node))) DOM_view.set(node, _this);
                        break;
                    case 3:
                        if (!node.nodeValue.trim()) return;
                }

                return true;
            });else if (!(_this_ = DOM_view.get(template))) DOM_view.set(template, this);

            view_DOM.set(this, template);

            return _this_ || this;
        }

        /**
         * @param {Element|DocumentFragment} node
         *
         * @return {View} View instance bound with `node`
         */

    }, {
        key: 'toString',


        /**
         * @return {string} Full markup code of this view
         */
        value: function toString() {

            var content = this.content;

            return content.nodeType === 1 ? content.outerHTML : Array.from(content.childNodes || content, function (node) {

                switch (node.nodeType) {
                    case 1:
                        return node.outerHTML;
                    case 3:
                        return node.nodeValue;
                }
            }).join('');
        }

        /**
         * @protected
         *
         * @type {Object}
         */

    }, {
        key: 'valueOf',


        /**
         * Get original data of this view
         *
         * @return {Object}
         */
        value: function valueOf() {

            throw TypeError('View.prototype.valueOf() must be overwriten');
        }

        /**
         * Render this view
         *
         * @return {View}
         */

    }, {
        key: 'render',
        value: function render() {

            throw TypeError('View.prototype.render() must be overwriten');
        }

        /**
         * Reset this view to empty data
         *
         * @return {View}
         */

    }, {
        key: 'clear',
        value: function clear() {

            throw TypeError('View.prototype.clear() must be overwriten');
        }
    }, {
        key: 'content',


        /**
         * @type {Element|Element[]|DocumentFragment}
         */
        get: function get() {
            return view_DOM.get(this);
        }
    }, {
        key: 'data',
        get: function get() {
            return view_data.get(this);
        }
    }], [{
        key: 'import',
        value: function _import(node) {
            return document.importNode(node, true);
        }

        /**
         * @param {string} markup - Code of an markup fragment
         *
         * @return {Element[]}
         */

    }, {
        key: 'parseDOM',
        value: function parseDOM(markup) {

            markup = new window.DOMParser().parseFromString(markup, 'text/html');

            return Array.from(markup.head.childNodes, View.import).concat(Array.from(markup.body.childNodes, View.import));
        }
    }, {
        key: 'instanceOf',
        value: function instanceOf(node) {
            return DOM_view.get(node);
        }
    }]);

    return View;
}();

exports.default = View;}

function _Template(require, exports, module) {'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Array_iterator = [][Symbol.iterator];

/**
 * String template
 */

var Template = function () {
    /**
     * @param {string}          raw
     * @param {stirng[]}        [varName]  - Name list of the Local variable
     * @param {ChangedCallback} [onChange] - Call with New & Old value
     * @param {Array}           [bindData] - The parameter bound to `onChange`
     */
    function Template(raw, varName, onChange, bindData) {
        _classCallCheck(this, Template);

        this.length = 0;

        this.raw = raw, this.value = null;

        if (varName instanceof Function) bindData = onChange, onChange = varName, varName = null;

        this.varName = varName || [], this.expression = [];

        this.context = new Set(this.varName.concat('this'));

        this.onChange = onChange instanceof Function ? onChange : null;

        this.data = bindData || [];

        this.parse().clear();
    }

    _createClass(Template, [{
        key: Symbol.iterator,
        value: function value() {
            return Array_iterator.call(this);
        }

        /**
         * @type {RegExp}
         */

    }, {
        key: 'push',
        value: function push() {
            return Array.prototype.push.apply(this, arguments);
        }

        /**
         * @private
         *
         * @param {string} expression
         *
         * @return {number} Index of this Evaluation function
         */

    }, {
        key: 'compile',
        value: function compile(expression) {

            return this.expression.push(new (Function.prototype.bind.apply(Function, [null].concat(_toConsumableArray(this.varName), ['return ' + expression.trim()])))()) - 1;
        }

        /**
         * @private
         *
         * @return {Template}
         */

    }, {
        key: 'parse',
        value: function parse() {
            var _this = this;

            var addReference = function addReference(match, context, key1, key2, key3) {

                if (_this.context.has(context)) _this.push(key1 || key2 || key3);
            };

            this.raw = this.raw.replace(Template.Expression, function (_, expression) {

                expression.replace(Template.Reference, addReference);

                return '${' + _this.compile(expression) + '}';
            });

            return this;
        }

        /**
         * Evaluate expression
         *
         * @param {?object} context     - Value of `this` in the expression
         * @param {...*}    [parameter] - One or more value of the Local variable
         *
         * @return {string}
         */

    }, {
        key: 'evaluate',
        value: function evaluate(context) {
            var _this2 = this;

            for (var _len = arguments.length, parameter = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                parameter[_key - 1] = arguments[_key];
            }

            var value = this.raw.replace(/\$\{(\d+)\}/g, function (_, index) {
                return _this2.expression[index].apply(context, parameter);
            });

            if (value !== this.value) {
                /**
                 * Call back only on Value changed
                 *
                 * @typedef {function} ChangedCallback
                 *
                 * @param {*}    newValue
                 * @param {*}    oldValue
                 * @param {...*} bindData
                 */
                if (this.onChange) this.onChange.apply(this, _toConsumableArray([value, this.value].concat(this.data)));

                this.value = value;
            }

            return value;
        }

        /**
         * @return {string} Value evaluated with empty data
         */

    }, {
        key: 'clear',
        value: function clear() {

            var data = {};

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var key = _step.value;
                    data[key] = '';
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return this.evaluate.apply(this, _toConsumableArray(Array.from(this.context, function () {
                return data;
            })));
        }
    }, {
        key: 'toString',
        value: function toString() {

            return this.value + '';
        }
    }], [{
        key: 'Expression',
        get: function get() {
            return (/\$\{([\s\S]+?)\}/g
            );
        }

        /**
         * @type {RegExp}
         */

    }, {
        key: 'Reference',
        get: function get() {
            return (/(\w+)(?:\.(\w+)|\[(?:'([^']+)|"([^"]+)))/g
            );
        }
    }]);

    return Template;
}();

exports.default = Template;}

function _ArrayView(require, exports, module) {'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _View2 = require('./View');

var _View3 = _interopRequireDefault(_View2);

var _ObjectView = require('./ObjectView');

var _ObjectView2 = _interopRequireDefault(_ObjectView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Array_iterator = [][Symbol.iterator];

/**
 * View for Array model
 */

var ArrayView = function (_View) {
    _inherits(ArrayView, _View);

    /**
     * @param {Element} element
     */
    function ArrayView(element) {
        var _this;

        _classCallCheck(this, ArrayView);

        if (!(_this = _possibleConstructorReturn(this, (ArrayView.__proto__ || Object.getPrototypeOf(ArrayView)).call(this, element, 'array', [])), _this).booted) {

            _this.template = element.innerHTML.trim();_this.clear();
        }
        return _possibleConstructorReturn(_this);
    }

    _createClass(ArrayView, [{
        key: Symbol.iterator,
        value: function value() {
            return Array_iterator.call(this);
        }
    }, {
        key: 'clear',
        value: function clear() {

            Array.prototype.splice.call(this, 0, Infinity);

            this.content.innerHTML = '';

            return this;
        }
    }, {
        key: 'valueOf',
        value: function valueOf() {
            return Array.from(this, function (view) {
                return view.valueOf();
            });
        }

        /**
         * @param {Iterable} list
         *
         * @return {ArrayView}
         */

    }, {
        key: 'render',
        value: function render(list) {
            var _content,
                _ref,
                _this2 = this;

            var data = this.data;

            (_content = this.content).append.apply(_content, _toConsumableArray((_ref = []).concat.apply(_ref, _toConsumableArray(Array.from(list, function (item) {

                var view = _this2[_this2.length++] = new _ObjectView2.default(_this2.template);

                data[data.length] = view.data;

                return view.render(item).content;
            })))));

            return this;
        }
    }, {
        key: 'push',
        value: function push() {
            for (var _len = arguments.length, item = Array(_len), _key = 0; _key < _len; _key++) {
                item[_key] = arguments[_key];
            }

            return this.render(item).length;
        }
    }]);

    return ArrayView;
}(_View3.default);

exports.default = ArrayView;}

function _ObjectView(require, exports, module) {'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _View2 = require('./View');

var _View3 = _interopRequireDefault(_View2);

var _WebCell = require('./WebCell');

var _Template = require('./Template');

var _Template2 = _interopRequireDefault(_Template);

var _ArrayView = require('./ArrayView');

var _ArrayView2 = _interopRequireDefault(_ArrayView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Array_iterator = [][Symbol.iterator],
    template_element = new WeakMap();

/**
 * View for Object model
 */

var ObjectView = function (_View) {
    _inherits(ObjectView, _View);

    /**
     * @param {string|Element|DocumentFragment} template
     */
    function ObjectView(template) {
        var _this;

        _classCallCheck(this, ObjectView);

        if (!(_this = _possibleConstructorReturn(this, (ObjectView.__proto__ || Object.getPrototypeOf(ObjectView)).call(this, template, 'object', {})), _this).booted) _this.length = 0, _this.scan();
        return _possibleConstructorReturn(_this);
    }

    _createClass(ObjectView, [{
        key: Symbol.iterator,
        value: function value() {
            return Array_iterator.call(this);
        }
    }, {
        key: 'valueOf',
        value: function valueOf() {

            var data = Object.assign({}, this.data);

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var template = _step.value;

                    if (template instanceof _View3.default) data[template.name] = template.valueOf();
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return data;
        }

        /**
         * @private
         *
         * @param {Node|Attr} node
         * @param {function}  renderer
         *
         * @return {Template}
         */

    }, {
        key: 'register',


        /**
         * @private
         *
         * @param {Element|View} element
         * @param {Template}     [template]
         */
        value: function register(element, template) {

            if (element instanceof _View3.default) this[this.length++] = element;else if (template[0]) template_element.set(this[this.length++] = template, element);
        }

        /**
         * @private
         *
         * @param {Element} element
         */

    }, {
        key: 'parseTag',
        value: function parseTag(element) {
            var _this2 = this;

            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                var _loop = function _loop() {
                    var attr = _step2.value;


                    var name = attr.name;

                    var template = ObjectView.templateOf(attr, name in element ? function (value) {
                        return element[name] = value;
                    } : function (value) {
                        return element.setAttribute(name, value);
                    });

                    if (template == '') element.removeAttribute(name);

                    _this2.register(element, template);
                };

                for (var _iterator2 = element.attributes[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    _loop();
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }
        }

        /**
         * @private
         */

    }, {
        key: 'scan',
        value: function scan() {
            var _this3 = this;

            var root = this.content;

            root = root.parentNode ? root : {
                childNodes: root instanceof Array ? root : [root]
            };

            (0, _WebCell.mapTree)(root, 'childNodes', function (node) {

                switch (node.nodeType) {
                    case 1:
                        if (node.dataset.object) _this3.register(new ObjectView(node));else if (node.dataset.array) _this3.register(new _ArrayView2.default(node));else _this3.parseTag(node);
                        break;
                    case 3:
                        _this3.register(node, ObjectView.templateOf(node, function (value) {
                            return node.nodeValue = value;
                        }));
                }

                return node;
            });
        }

        /**
         * @param {Object} data
         *
         * @return {ObjectView}
         */

    }, {
        key: 'render',
        value: function render(data) {

            var _data_ = Object.assign(this.data, data);

            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                for (var _iterator3 = this[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var template = _step3.value;


                    var _name = template.name;

                    if (template instanceof _Template2.default) template.evaluate(template_element.get(template), _data_);else if (template instanceof _View3.default && data[_name]) _data_[_name] = template.render(data[_name]).data;
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }

            return this;
        }
    }, {
        key: 'clear',
        value: function clear() {
            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;

            try {

                for (var _iterator4 = this[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                    var template = _step4.value;
                    template.clear();
                }
            } catch (err) {
                _didIteratorError4 = true;
                _iteratorError4 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion4 && _iterator4.return) {
                        _iterator4.return();
                    }
                } finally {
                    if (_didIteratorError4) {
                        throw _iteratorError4;
                    }
                }
            }

            return this;
        }
    }], [{
        key: 'templateOf',
        value: function templateOf(node, renderer) {

            return new _Template2.default(node.value || node.nodeValue, ['view'], renderer);
        }
    }]);

    return ObjectView;
}(_View3.default);

exports.default = ObjectView;}

function _Component(require, exports, module) {'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _View = require('./View');

var _View2 = _interopRequireDefault(_View);

var _ObjectView = require('./ObjectView');

var _ObjectView2 = _interopRequireDefault(_ObjectView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Utility methods of Web Component
 */
var Component = function () {
    function Component() {
        _classCallCheck(this, Component);
    }

    _createClass(Component, [{
        key: 'buildDOM',


        /**
         * @return {HTMLElement} This custom element
         */
        value: function buildDOM() {

            var shadow = this.attachShadow({
                mode: 'open',
                delegatesFocus: true
            });

            shadow.append(document.importNode(this.constructor.template, true));

            new _ObjectView2.default(shadow);

            return this;
        }

        /**
         * Main view of this component
         *
         * @type {View}
         */

    }, {
        key: 'attributeChangedCallback',
        value: function attributeChangedCallback(name, oldValue, newValue) {

            switch (newValue) {
                case '':
                    this[name] = true;break;
                case null:
                    this[name] = false;break;
                default:
                    try {
                        this[name] = JSON.parse(newValue);
                    } catch (error) {

                        this[name] = newValue;
                    }
            }
        }

        /**
         * @param {Element} element
         *
         * @return {number} The index of `element` in its siblings
         */

    }, {
        key: '$',


        /**
         * @param {string} selector
         *
         * @return {Element[]} Element set which matches `selector` in this Shadow DOM
         */
        value: function $(selector) {

            return [].concat(_toConsumableArray(this.shadowRoot.querySelectorAll(selector)));
        }
    }, {
        key: 'view',
        get: function get() {
            return _View2.default.instanceOf(this.shadowRoot);
        }

        /**
         * Define a set of Getter or Setter for DOM properties,
         * and store their values into private object.
         *
         * @param {Object} map - `1` for Getter, `2` for Setter & sum for both
         *                       in each key's value
         * @return {string[]} Keys of `map`
         *
         * @example
         *
         *    WebCell.component(class MyInput extends HTMLElement {
         *
         *        constructor() {  super();  }
         *
         *        static get observedAttributes() {
         *
         *            return this.setAccessor({
         *                value:  1,
         *                step:   3
         *            });
         *        }
         *    });
         */

    }], [{
        key: 'setAccessor',
        value: function setAccessor(map) {
            var _this = this;

            var _loop = function _loop(key) {

                var config = { enumerable: true };

                if (map[key] & 1) config.get = function () {

                    return this.view.valueOf()[key];
                };

                if (map[key] & 2) config.set = function (value) {

                    this.view.render(_defineProperty({}, key, value));
                };

                Object.defineProperty(_this.prototype, key, config);
            };

            for (var key in map) {
                _loop(key);
            }

            return Object.keys(map);
        }
    }, {
        key: 'indexOf',
        value: function indexOf(element) {

            var index = 0;

            while (element = element.previousElementSibling) {
                index++;
            }return index;
        }

        /**
         * @param {Event} event
         *
         * @return {Element} The target of `event` object (**Shadow DOM** is in account)
         */

    }, {
        key: 'targetOf',
        value: function targetOf(event) {

            var target = event.composedPath ? event.composedPath() : event.path;

            return (target || '')[0] || event.target;
        }

        /**
         * @protected
         *
         * @return   {Object}
         * @property {HTMLTemplateElement}                      template
         * @property {Array<HTMLStyleElement, HTMLLinkElement>} style
         * @property {HTMLScriptElement}                        script
         */

    }, {
        key: 'findTemplate',
        value: function findTemplate() {
            var _template;

            var script = document.currentScript,
                template,
                style = [];

            var element = script,
                stop;

            while (!stop && (element = element.previousElementSibling)) {
                switch (element.tagName.toLowerCase()) {
                    case 'template':
                        template = element.content;break;
                    case 'style':
                        style.unshift(element);break;
                    case 'link':
                        if (element.rel === 'stylesheet') {

                            element.setAttribute('href', element.href);

                            style.unshift(element);
                        }
                        break;
                    case 'script':
                        stop = true;
                }
            }if (style[0]) (_template = template).prepend.apply(_template, style);

            return { template: template, style: style, script: script };
        }
    }, {
        key: 'tagName',

        /**
         * @type {string} - `tagName` of a Custom Element
         */
        get: function get() {

            return this.name.replace(/[A-Z]/g, function (char) {
                return '-' + char.toLowerCase();
            }).slice(1);
        }
    }]);

    return Component;
}();

exports.default = Component;}

function _WebCell(require, exports, module) {'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.multipleMap = multipleMap;
exports.extend = extend;
exports.mapTree = mapTree;
exports.component = component;

var _Component = require('./Component');

var _Component2 = _interopRequireDefault(_Component);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/**
 * Equivalent to the integration of Array's map() & filter() methods
 *
 * @param {Iterable}                                           list
 * @param {function(item: *, index: number, list:Iterable): *} filter
 *     - Return `item` itself to reserve, `undefined` or `null` to ignore, or Array to merge in.
 *
 * @return {Array}
 */
function multipleMap(list, filter) {

    var result = [];filter = filter instanceof Function && filter;

    for (var i = 0; i < list.length; i++) {

        var item = filter ? filter(list[i], i, list) : list[i];

        if (item != null) if (item instanceof Array) result.push.apply(result, _toConsumableArray(item));else result.push(item);
    }

    return result;
}

/**
 * Merge own properties of two or more objects together into the first object
 * by their descriptor
 *
 * @param {Object}    target - An object that will receive the new properties
 *                             if `source` are passed in
 * @param {...Object} source - Additional objects containing properties to merge in
 *
 * @return {Object} The `target` parameter
 */
function extend(target) {
    for (var _len = arguments.length, source = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        source[_key - 1] = arguments[_key];
    }

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {

        for (var _iterator = source[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var object = _step.value;
            if (object instanceof Object) {

                var descriptor = Object.getOwnPropertyDescriptors(object);

                if (object instanceof Function) {

                    delete descriptor.name;
                    delete descriptor.length;
                    delete descriptor.prototype;

                    var prototype = Object.getOwnPropertyDescriptors(object.prototype);

                    delete prototype.constructor;

                    Object.defineProperties(target.prototype, prototype);
                }

                Object.defineProperties(target, descriptor);
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    return target;
}

var depth = 0;

/**
 * Traverse Object-tree & return Node array through the filter
 *
 * @param {object}        node     - Object tree
 * @param {string}        fork_key - Key of children list
 * @param {MapTreeFilter} filter   - Map filter
 *
 * @return {Array}  Result list of Map filter
 */
function mapTree(node, fork_key, filter) {

    var children = node[fork_key],
        list = [];depth++;

    for (var i = 0, value; i < children.length; i++) {
        /**
         * @typedef {function} MapTreeFilter
         *
         * @param {object} child
         * @param {number} index
         * @param {number} depth
         *
         * @return {?object}  `Null` or `Undefined` to **Skip the Sub-Tree**,
         *                    and Any other Type to Add into the Result Array.
         */
        try {
            value = filter.call(node, children[i], i, depth);
        } catch (error) {

            depth = 0;throw error;
        }

        if (!(value != null)) continue;

        list.push(value);

        if (children[i] != null && (children[i][fork_key] || '')[0]) list.push.apply(list, mapTree(children[i], fork_key, filter));
    }

    depth--;

    return list;
}

/**
 * Register a component
 *
 * @param {function} subClass
 *
 * @return {function} `subClass`
 */
function component(subClass) {
    var _Component$findTempla = _Component2.default.findTemplate(),
        template = _Component$findTempla.template;

    extend(subClass, _Component2.default, {
        get template() {
            return template;
        }
    });

    customElements.define(subClass.tagName, subClass);

    return subClass;
}}

    module['./View'].exports = _View(_require_.bind(null, '.'), require('./View'), module['./View']) || require('./View');

    module['./Template'].exports = _Template(_require_.bind(null, '.'), require('./Template'), module['./Template']) || require('./Template');

    module['./ArrayView'].exports = _ArrayView(_require_.bind(null, '.'), require('./ArrayView'), module['./ArrayView']) || require('./ArrayView');

    module['./ObjectView'].exports = _ObjectView(_require_.bind(null, '.'), require('./ObjectView'), module['./ObjectView']) || require('./ObjectView');

    module['./Component'].exports = _Component(_require_.bind(null, '.'), require('./Component'), module['./Component']) || require('./Component');

    module['./WebCell'].exports = _WebCell(_require_.bind(null, '.'), require('./WebCell'), module['./WebCell']) || require('./WebCell');

    return require('./WebCell');
});